#!/bin/bash

function usage
{
	echo "usage "
	echo "	: on       ;relay 1~8(channel)/X(All)   ./relay.sh 192.168.1.100 on 1~8/X,  example: ./relay.sh 192.168.1.100 on 1;./relay.sh 192.168.1.100 on X"
	echo "	: off      ;relay 1~8(channel)/X(All)   ./relay.sh 192.168.1.100 off 1~8/X, example: ./relay.sh 192.168.1.100 off 1;./relay.sh 192.168.1.100 off X"
	echo "	: delay    ;example delay 5 second: ./relay.sh 192.168.1.100 delay off 1 5;./relay.sh 192.168.1.100 delay off X 5"
	echo "	: jogging  ;example jogging 500ms: ./relay.sh 192.168.1.100 delay off 1;./relay.sh 192.168.1.100 delay off X"
	echo "	: raw      ;use raw dingtian-string protocol example: ./relay.sh 192.168.1.100 raw 12;./relay.sh 192.168.1.100 raw 22;"
	echo "	: status   ;get relay board relay and input status example: ./relay.sh 192.168.1.100 status"
}

function status()
{
	exec 8<>/dev/udp/$1/60001

	if(($?!=0));then
		echo "Open UDP port 60001 error!"
		exit 1;
	fi

	echo -en "00">&8

	cat<&8
	exec 8<&-
	exec 8>&-
}

function on_off()
{
	cmd=$2
	if [ ${2} == "off" ]; then
		cmd=2
	else
		cmd=1
	fi
	cmd+=$3
	echo ${cmd}

	echo -en "${cmd}" > /dev/udp/$1/60001
}

function delay()
{
	cmd=$2
	if [ ${2} == "off" ]; then
		cmd=2
	else
		cmd=1
	fi
	cmd+=$3
	cmd+=':'
	cmd+=$4
	echo ${cmd}

	echo -en "${cmd}" > /dev/udp/$1/60001
}

function jogging()
{
	cmd=$2
	if [ ${2} == "off" ]; then
		cmd=2
	else
		cmd=1
	fi
	cmd+=$3
	cmd+='*'
	echo ${cmd}

	echo -en "${cmd}" > /dev/udp/$1/60001
}

function raw()
{
	echo -en "$2" > /dev/udp/$1/60001
}

#---------------------------------
#main
#---------------------------------
if [ $# -eq 0 ];then
	usage
else
	case "$2" in
		status)
			status $1
			;;
		on)
			on_off $1 $2 $3
			;;
		off)
			on_off $1 $2 $3
			;;
		delay)
			delay $1 $3 $4 $5
			;;
		jogging)
			jogging $1 $3 $4
			;;
		raw)
			raw $1 $3
			;;
		*)
			usage
			;;
	esac
fi
